Page MenuHomeFreeBSD

D25631.id74432.diff
No OneTemporary

D25631.id74432.diff

Index: share/man/man5/periodic.conf.5
===================================================================
--- share/man/man5/periodic.conf.5
+++ share/man/man5/periodic.conf.5
@@ -257,6 +257,17 @@
Set to
.Dq Li YES
to create backup of EFI System Partion (ESP).
+.It Va daily_backup_gmirror_enable
+.Pq Vt bool
+Set to
+.Dq Li YES
+to create backup of gmirror information, (i.e. output of `gmirror list`).
+.It Va daily_backup_gmirror_verbose
+.Pq Vt bool
+Set to
+.Dq Li YES
+to be verbose if the existing backup differs from the new backup,
+(i.e. show diff output between the two backups).
.It Va daily_backup_gpart_enable
.Pq Vt bool
Set to
Index: usr.sbin/periodic/etc/daily/222.backup-gmirror
===================================================================
--- /dev/null
+++ usr.sbin/periodic/etc/daily/222.backup-gmirror
@@ -0,0 +1,74 @@
+#!/bin/sh
+
+## $Id: 222.backup-gmirror.sh 9fb4e01613c0 2017-09-27 11:57 +0200 lachman $
+## Created by: Miroslav Lachman <000.fbsd@quip.cz>
+
+## Backup is the result from `gmirror list` - detailed information of all gmirrors.
+## Data is stored on the local filesystem, in /var/backups.
+## It is recommended to copy those files to off-site storage.
+
+
+## If there is a global system configuration file, suck it in.
+##
+if [ -r /etc/defaults/periodic.conf ]
+then
+ . /etc/defaults/periodic.conf
+ source_periodic_confs
+fi
+
+bak_dir=/var/backups
+
+rotate() {
+ base_name=$1
+ show_diff=$2
+ file="$bak_dir/$base_name"
+
+ if [ -f "${file}.bak" ]; then
+ rc=0
+ if cmp -s "${file}.bak" "${file}.tmp"; then
+ rm "${file}.tmp"
+ else
+ rc=1
+ [ -n "$show_diff" ] && diff "${file}.bak" "${file}.tmp"
+ mv "${file}.bak" "${file}.bak2" || rc=3
+ mv "${file}.tmp" "${file}.bak" || rc=3
+ fi
+ else
+ rc=1
+ mv "${file}.tmp" "${file}.bak" || rc=3
+ [ -n "$show_diff" ] && cat "${file}.bak"
+ fi
+}
+
+case "$daily_backup_gmirror_verbose" in
+ [Yy][Ee][Ss]) show="YES"
+esac
+
+case "$daily_backup_gmirror_enable" in
+ [Yy][Ee][Ss])
+
+ gmirrors=$(gmirror status 2> /dev/null | \
+ awk '$1 ~ /^mirror\// { sub(/mirror\//, ""); print $1 }')
+
+ if [ -z "$gmirrors" ]; then
+ echo ""
+ echo "daily_backup_gmirror_enable is set to YES but no gmirrors found."
+ rc=2
+ else
+ echo ""
+ echo "Backup of gmirror information for:";
+
+ for m in ${gmirrors}; do
+ echo "$m"
+ safe_name=$(echo "gmirror.${m}" | tr -cs ".[:alnum:]\n" "_")
+ if ! gmirror status -s "${m}" | grep -F -v "COMPLETE"; then
+ gmirror list "${m}" > "$bak_dir/$safe_name.tmp"
+ rotate "$safe_name" $show
+ fi
+ done
+ fi
+ ;;
+ *) rc=0;;
+esac
+
+exit $rc
Index: usr.sbin/periodic/etc/daily/Makefile
===================================================================
--- usr.sbin/periodic/etc/daily/Makefile
+++ usr.sbin/periodic/etc/daily/Makefile
@@ -11,6 +11,7 @@
200.backup-passwd \
210.backup-aliases \
221.backup-gpart \
+ 222.backup-gmirror \
330.news \
400.status-disks \
401.status-graid \
Index: usr.sbin/periodic/periodic.conf
===================================================================
--- usr.sbin/periodic/periodic.conf
+++ usr.sbin/periodic/periodic.conf
@@ -79,9 +79,13 @@
# 221.backup-gpart
daily_backup_gpart_enable="YES" # Backup partition table/boot partition/MBR
-daily_backup_gpart_verbose="NO" # Be verbose if new backup differs from the new one
+daily_backup_gpart_verbose="NO" # Be verbose if new backup differs from the old one
daily_backup_efi_enable="NO" # Backup EFI system partition (ESP)
+# 222.backup-gmirror
+daily_backup_gmirror_enable="NO" # Backup of gmirror info (i.e. output of `gmirror list`)
+daily_backup_gmirror_verbose="NO" # Be verbose if new backup differs from the old one
+
# 300.calendar
daily_calendar_enable="NO" # Run calendar -a

File Metadata

Mime Type
text/plain
Expires
Fri, Feb 27, 1:41 AM (14 h, 13 m)
Storage Engine
blob
Storage Format
Raw Data
Storage Handle
29010334
Default Alt Text
D25631.id74432.diff (3 KB)

Event Timeline